Bug 1300070 - Review Request: octave-doctest - Documentation tests for Octave
Summary: Review Request: octave-doctest - Documentation tests for Octave
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Antonio T. (sagitter)
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2016-01-19 21:31 UTC by Colin Macdonald
Modified: 2016-02-05 18:34 UTC (History)
1 user (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-02-05 18:34:20 UTC
Type: ---
anto.trande: fedora-review+


Attachments (Terms of Use)

Description Colin Macdonald 2016-01-19 21:31:07 UTC
Spec URL: https://cbm.fedorapeople.org/octave-doctest.spec
SRPM URL: https://cbm.fedorapeople.org/octave-doctest-0.4.1-1.fc23.src.rpm
Description:
The Octave-forge Doctest package finds specially-formatted blocks of
example code within documentation files.  It then executes the code
and confirms the output is correct.  This can be useful as part of a
testing framework or simply to ensure that documentation stays
up-to-date during software development.

Fedora Account System Username: cbm

Comment 1 Colin Macdonald 2016-01-19 21:42:19 UTC
Note: tarball exists on github but is not yet on sourceforge (which is the official upstream tarball).  It should be there soon and I'll post when it is.

Note: I didn't use %doc, even where some other octave-* packages did.  My reasoning re: "doc-cache" file:

> To summarize: If it is in %doc, the program must run properly
> if it is not > present.

https://fedoraproject.org/wiki/Packaging:ReviewGuidelines

Comment 2 Colin Macdonald 2016-01-19 21:43:52 UTC
$ koji build --scratch rawhide octave-doctest-0.4.1-1.fc23.src.rpm

http://koji.fedoraproject.org/koji/taskinfo?taskID=12612204

Comment 3 Upstream Release Monitoring 2016-01-19 21:46:28 UTC
cbm's scratch build of octave-doctest-0.4.1-1.fc23.src.rpm for rawhide failed http://koji.fedoraproject.org/koji/taskinfo?taskID=12612204

Comment 4 Upstream Release Monitoring 2016-01-19 22:31:26 UTC
cbm's scratch build of octave-doctest-0.4.1-1.fc23.src.rpm for rawhide failed http://koji.fedoraproject.org/koji/taskinfo?taskID=12612606

Comment 5 Upstream Release Monitoring 2016-01-19 22:31:31 UTC
cbm's scratch build of octave-doctest-0.4.1-1.fc23.src.rpm for f23 failed http://koji.fedoraproject.org/koji/taskinfo?taskID=12612612

Comment 6 Upstream Release Monitoring 2016-01-20 01:14:30 UTC
cbm's scratch build of octave-doctest-0.4.1-1.fc23.src.rpm for rawhide failed http://koji.fedoraproject.org/koji/taskinfo?taskID=12614261

Comment 7 Upstream Release Monitoring 2016-01-20 07:58:12 UTC
cbm's scratch build of octave-doctest-0.4.1-1.fc23.src.rpm for rawhide failed http://koji.fedoraproject.org/koji/taskinfo?taskID=12617065

Comment 8 Upstream Release Monitoring 2016-01-20 08:20:29 UTC
cbm's scratch build of octave-doctest-0.4.1-1.fc23.src.rpm for rawhide failed http://koji.fedoraproject.org/koji/taskinfo?taskID=12617211

Comment 9 Upstream Release Monitoring 2016-01-20 08:58:48 UTC
cbm's scratch build of octave-doctest-0.4.1-1.fc23.src.rpm for rawhide failed http://koji.fedoraproject.org/koji/taskinfo?taskID=12617577

Comment 10 Upstream Release Monitoring 2016-01-20 09:27:08 UTC
cbm's scratch build of octave-doctest-0.4.1-1.fc23.src.rpm for rawhide failed http://koji.fedoraproject.org/koji/taskinfo?taskID=12617888

Comment 11 Upstream Release Monitoring 2016-01-20 19:56:47 UTC
cbm's scratch build of octave-doctest-0.4.1-1.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12623460

Comment 12 Colin Macdonald 2016-01-20 20:53:25 UTC
Sorry for all the noise and for using koji to debug an upstream problem (I didn't have another arm box).  Next time I will do the koji scratch *before* submitting this request!

The sourceforge tarball is now live.  So its now ready for review...

Comment 13 Colin Macdonald 2016-01-20 20:53:48 UTC
Spec URL: https://cbm.fedorapeople.org/octave-doctest.spec
SRPM URL: https://cbm.fedorapeople.org/octave-doctest-0.4.1-2.fc23.src.rpm
Description:
The Octave-forge Doctest package finds specially-formatted blocks of
example code within documentation files.  It then executes the code
and confirms the output is correct.  This can be useful as part of a
testing framework or simply to ensure that documentation stays
up-to-date during software development.

Fedora Account System Username: cbm

Comment 14 Colin Macdonald 2016-01-20 20:54:39 UTC
Successful Koji scratch: http://koji.fedoraproject.org/koji/taskinfo?taskID=12624077

Note: I didn't use %doc, even where some other octave-* packages did.  My reasoning re: "doc-cache" file:

> To summarize: If it is in %doc, the program must run properly
> if it is not > present.

https://fedoraproject.org/wiki/Packaging:ReviewGuidelines

Comment 15 Antonio T. (sagitter) 2016-01-30 14:24:09 UTC
Unfortunately, does not compile on Rawhide:

make: Entering directory '/builddir/build/BUILD/doctest-0.4.1/src'
/usr/bin/mkoctfile-4.0.0 --verbose doctest_evalc.cc
g++ -c  -fPIC -I/usr/include/octave-4.0.0/octave/.. -I/usr/include/octave-4.0.0/octave -pthread -fopenmp -O2 -g -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -m64 -mtune=generic    doctest_evalc.cc -o doctest_evalc.o
g++ -shared -Wl,-Bsymbolic  -o doctest_evalc.oct  doctest_evalc.o   -L/usr/lib64/octave/4.0.0 -L/usr/lib64 -loctinterp -loctave -Wl,-z,relro -specs=/usr/lib/rpm/redhat/redhat-hardened-ld  
/usr/bin/ld: /usr/lib/gcc/x86_64-redhat-linux/6.0.0/crtbeginS.o: unrecognized relocation (0x2a) in section `.text'
/usr/bin/ld: final link failed: Bad value

Comment 16 Colin Macdonald 2016-01-31 17:24:51 UTC
Thanks!  That's strange b/c it build earlier... I'll investigate.

Comment 17 Upstream Release Monitoring 2016-01-31 17:44:19 UTC
cbm's scratch build of octave-doctest-0.4.1-2.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12760452

Comment 18 Colin Macdonald 2016-01-31 17:45:34 UTC
Ok Koji rawhide is fine, but I can reproduce in a local virtual machine.

Comment 19 Colin Macdonald 2016-01-31 17:53:31 UTC
Hmmm, updating my "binutils" from 2.25.1-9 to 2.26-4 on my VM fixed this for me.  Is it possible your rawhide is also not up-to-date?

Comment 20 Antonio T. (sagitter) 2016-01-31 21:27:26 UTC
(In reply to Colin Macdonald from comment #19)
> Hmmm, updating my "binutils" from 2.25.1-9 to 2.26-4 on my VM fixed this for
> me.  Is it possible your rawhide is also not up-to-date?

'binutils' is not among BuildRequires packages.
List all packages necessary for building.

Comment 21 Colin Macdonald 2016-01-31 22:05:18 UTC
Thanks.  I think the BR on octave-devel will cover that.  But I can certainly add it along with any other revisions from review.

Comment 22 Upstream Release Monitoring 2016-02-02 18:07:09 UTC
sagitter's scratch build of octave-doctest-0.4.1-2.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12790193

Comment 23 Antonio T. (sagitter) 2016-02-02 18:28:52 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed

Issues:

- '%global __provides_exclude_from ^%{octpkglibdir}/.*\\.oct$' is
  missing

- Validation of metainfo.xml file is not need.
https://fedoraproject.org/wiki/Packaging:AppData#app-data-validate_usage

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[-]: Development (unversioned) .so files in -devel subpackage, if present.
[-]: Header files in -devel subpackage, if present.
[-]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[-]: Package uses nothing in %doc for runtime.
[-]: The spec file handles locales properly.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
[!]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
[-]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[-]: Package contains desktop file if it is a GUI application.
[-]: Package installs a %{name}.desktop using desktop-file-install or
     desktop-file-validate if there is such a file.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
[ ]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: SourceX tarball generation or download is documented.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[-]: Package should not use obsolete m4 macros
[x]: Rpmlint is run on debuginfo package(s).
[x]: Rpmlint is run on all installed packages.
[-]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.

$ rpmlint octave-doctest octave-doctest-debuginfo
octave-doctest.x86_64: W: no-documentation
octave-doctest.x86_64: W: dangerous-command-in-%preun mv
2 packages and 0 specfiles checked; 0 errors, 2 warnings.

Comment 24 Colin Macdonald 2016-02-03 18:53:47 UTC
Thank you for the review!

1.  I hope I have addressed your comments, except for the rpmlint warnings:

>> octave-doctest.x86_64: W: no-documentation

Noted above: all doc files are needed for package to function correctly thus not marked %doc.

>> octave-doctest.x86_64: W: dangerous-command-in-%preun mv

I think this is from the .macro file


2.  I don't really understand the __exclude_exclude: in particular, is it correct to place it at the top of the file?


3.  Updated files:

Spec URL: https://cbm.fedorapeople.org/octave-doctest.spec
SRPM URL: https://cbm.fedorapeople.org/octave-doctest-0.4.1-3.fc23.src.rpm


4.  A diff of my changes:
https://cbm.fedorapeople.org/octave-doctest-0.4.1-2-3.diff

Comment 25 Colin Macdonald 2016-02-03 18:55:22 UTC
Sorry, meant "__provides_exclude_".  I just copy-pasted what you said to the top of the file.  I can't find other octave-pkgs that do this: maybe they should!

Comment 26 Antonio T. (sagitter) 2016-02-03 19:07:18 UTC
(In reply to Colin Macdonald from comment #24)
> Thank you for the review!
> 
> 1.  I hope I have addressed your comments, except for the rpmlint warnings:
> 
> >> octave-doctest.x86_64: W: no-documentation
> 
> Noted above: all doc files are needed for package to function correctly thus
> not marked %doc.
> 
> >> octave-doctest.x86_64: W: dangerous-command-in-%preun mv
> 
> I think this is from the .macro file
> 
> 
> 2.  I don't really understand the __exclude_exclude: in particular, is it
> correct to place it at the top of the file?
> 

It's provided for by guidelines for Octave packages: 

http://fedoraproject.org/wiki/Packaging:Octave#Arch_specific_Octave_spec_template

> 
> 3.  Updated files:
> 
> Spec URL: https://cbm.fedorapeople.org/octave-doctest.spec
> SRPM URL: https://cbm.fedorapeople.org/octave-doctest-0.4.1-3.fc23.src.rpm
> 
> 

Package approved.

Comment 27 Gwyn Ciesla 2016-02-04 13:41:22 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/octave-doctest


Note You need to log in before you can comment on or make changes to this bug.